%global momorel 11
%global pythonver 2.5.1-11m

# Hypervisor ABI
%define hv_abi  3.2
# Whether to build -hypervisor pacakges
%define hv_build 1

%{!?python_sitearch: %global python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)")}

Summary: Xen is a virtual machine monitor
Name:    xen
Version: 3.2.0
Release: %{momorel}m%{?dist}
Group:   Development/Libraries
License: GPL
URL:     http://xen.org/
Source0: http://bits.xensource.com/oss-xen/release/%{version}/xen-%{version}.tar.gz 
NoSource:0
# Source0: xen-%{version}-src.tgz
Source1: %{name}.modules
Source2: %{name}.logrotate
Patch1: xen-initscript.patch
Patch3: xen-compile-fixes.patch
Patch6: xen-hvm-kernel-boot-relocatable.patch
Patch5: xen-hvm-kernel-boot-xend.patch
Patch7: xen-hvm-kernel-boot-nonrelocatable.patch
Patch8: xen-xenstore-cli.patch
Patch13: xen-dumpdir.patch

Patch36: xen-qemu-bootmenu.patch

# Patches to modify the default config of xend
Patch100: xen-config-dom0-minmem.patch
Patch102: xen-3.0.2-config-allow-unix-server.patch
Patch103: xen-3.0.2-config-disable-reloc.patch

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires: transfig libidn-devel zlib-devel texi2html SDL-devel curl-devel
BuildRequires: libX11-devel
BuildRequires: python-devel >= %{pythonver}
BuildRequires: ghostscript tetex-latex 
BuildRequires: ncurses-devel gtk2-devel libaio-devel
# for the docs 
BuildRequires: perl 
# so that the makefile knows to install udev rules
BuildRequires: udev 
%ifnarch ia64
# so that x86_64 builds pick up glibc32 correctly
BuildRequires: /usr/include/gnu/stubs-32.h
# for the VMX "bios" 
BuildRequires: dev86
%endif
BuildRequires: gettext
BuildRequires: gnutls-devel >= 2.4.1
BuildRequires: openssl-devel
Requires: bridge-utils
Requires: udev >= 059
Requires: python-virtinst
Requires: xen-libs = %{version}-%{release}
# Not strictly a dependency, but kpartx is by far the most useful tool right
# now for accessing domU data from within a dom0 so bring it in when the user
# installs xen.
Requires: kpartx
Requires: initscripts
Prereq: chkconfig
ExclusiveArch: %{ix86} x86_64 ia64

%description
This package contains the Xen hypervisor and Xen tools, needed to
run virtual machines on x86 systems, together with the kernel-xen*
packages.  Information on how to use Xen can be found at the Xen
project pages.

Virtualisation can be used to run multiple versions or multiple
Linux distributions on one system, or to test untrusted applications
in a sandboxed environment.  

%package libs
Summary: Libraries for Xen tools
Group: Development/Libraries
Requires(pre): /sbin/ldconfig
Requires(post): /sbin/ldconfig

%description libs
This package contains the libraries needed to run applications
which manage Xen virtual machines.

%package runtime
Summary: Core Xen runtime environment
Group: Development/Libraries
Requires: xen = %{version}-%{release}
Requires: xen-libs = %{version}-%{release}
# Ensure we at least have a suitable kernel installed, though we can't
# force user to actually boot it.
Requires: xen-hypervisor-abi = %{hv_abi}

%description runtime
This package contains the runtime programs and daemons which
form the core Xen userspace environment.

%if %{hv_build}
%package hypervisor
Summary: Libraries for Xen tools
Group: Development/Libraries
Provides: xen-hypervisor-abi = %{hv_abi}

%description hypervisor
This package contains the Xen hypervisor
%endif

%package devel
Summary: Development libraries for Xen tools
Group: Development/Libraries
Requires: xen-libs = %{version}-%{release}

%description devel
This package contains what's needed to develop applications
which manage Xen virtual machines.

%prep
%setup -q
%patch1 -p1
%patch3 -p1 
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch13 -p1

%patch36 -p1

# config patches
%patch100 -p1
%patch102 -p1
%patch103 -p1

%build
%if %{hv_build}
CFLAGS="$RPM_OPT_FLAGS" %{__make} XEN_PYTHON_NATIVE_INSTALL=1 DESTDIR=%{buildroot} tools docs xen
%else
CFLAGS="$RPM_OPT_FLAGS" %{__make} XEN_PYTHON_NATIVE_INSTALL=1 DESTDIR=%{buildroot} tools docs
%endif

%install
rm -rf %{buildroot}
make XENFB_TOOLS=y XEN_PYTHON_NATIVE_INSTALL=1 DESTDIR=%{buildroot} prefix=/usr install-tools install-docs
mkdir -p %{buildroot}%{_localstatedir}/lib/%{name}/xend-db/domain
mkdir -p %{buildroot}%{_localstatedir}/lib/%{name}/xend-db/vnet
mkdir -p %{buildroot}%{_localstatedir}/lib/%{name}/xend-db/migrate
mkdir -p %{buildroot}%{_localstatedir}/lib/xenstored
mkdir -p %{buildroot}%{_localstatedir}/run/xenstored

rm -rf %{buildroot}%{_sysconfdir}/hotplug

# install all of the public headers
mkdir -p %{buildroot}%{_includedir}/xen/io %{buildroot}%{_includedir}/xen/hvm
mkdir -p %{buildroot}%{_includedir}/xen/arch-x86 %{buildroot}%{_includedir}/xen/xsm
install -m 644 xen/include/public/io/*.h %{buildroot}%{_includedir}/xen/io
install -m 644 xen/include/public/hvm/*.h %{buildroot}%{_includedir}/xen/hvm
install -m 644 xen/include/public/xsm/*.h %{buildroot}%{_includedir}/xen/xsm
install -m 644 xen/include/public/arch-x86/*.h %{buildroot}%{_includedir}/xen/arch-x86
install -m 644 xen/include/public/*.h %{buildroot}%{_includedir}/xen/

%if %{hv_build}
# install the hypervisor
install -d 755 %{buildroot}/boot/
install -m 644 xen/xen.gz %{buildroot}/boot/xen-%{hv_abi}.gz
install -m 644 xen/xen-syms %{buildroot}/boot/xen-syms-%{hv_abi}
%endif

### fixing start-script dir
mv -f %{buildroot}%{_sysconfdir}/udev/xen-backend.rules %{buildroot}%{_sysconfdir}/udev/rules.d/

mkdir -p %{buildroot}%{_sysconfdir}/sysconfig/modules
install -m 644 %{SOURCE1} %{buildroot}%{_sysconfdir}/sysconfig/modules/%{name}.modules

mkdir -p %{buildroot}%{_sysconfdir}/logrotate.d/
install -m 644 %{SOURCE2} %{buildroot}%{_sysconfdir}/logrotate.d/%{name}

# Pointless wrapper
rm -f %{buildroot}%{_libdir}/%{name}/bin/qemu-dm.debug
# Pointless helper
rm -f %{buildroot}%{_sbindir}/xen-python-path
# Just plain evil
rm -f %{buildroot}%{_sbindir}/netfix

# Tools that upstream are dropping
# ...replaced by kpartx
rm -f %{buildroot}%{_bindir}/lomount
# ...replaced by any serial console program
rm -f %{buildroot}%{_bindir}/xencons

# Not built into our Xen kernels
rm -f %{buildroot}%{_bindir}/xenperf
rm -f %{buildroot}%{_sbindir}/xenperf

# Doesn't work
rm -f %{buildroot}%{_sbindir}/xsview

# silly doc dir fun
rm -fr %{buildroot}%{_datadir}/doc/xen/
rm -rf %{buildroot}%{_datadir}/doc/qemu/

# create dirs in /var/run so that selinux contexts are right (#195952)
mkdir -p %{buildroot}%{_localstatedir}/run/xend
mkdir -p %{buildroot}%{_localstatedir}/log/xen
mkdir -p %{buildroot}%{_localstatedir}/log/xen/console
mkdir -p %{buildroot}%{_localstatedir}/lib/xen/images

# avoid conflicting with qemu (#199759)
rm -f %{buildroot}/%{_mandir}/man*/qemu*

#find_lang xen-xm

%post
/sbin/chkconfig --add xend
/sbin/chkconfig --add xendomains

if [ $1 != 0 ]; then
  /sbin/service xend condrestart
fi

%preun
if [ $1 = 0 ]; then
  /sbin/chkconfig --del xend
  /sbin/chkconfig --del xendomains
fi

%post runtime
/sbin/chkconfig --add xenconsoled
/sbin/chkconfig --add xenstored
/sbin/chkconfig --add blktapctrl

if [ $1 != 0 ]; then
  service xenconsoled condrestart
fi

%preun runtime
if [ $1 = 0 ]; then
  /sbin/chkconfig --del xenconsoled
  /sbin/chkconfig --del xenstored
  /sbin/chkconfig --del blktapctrl
fi

%post libs -p /sbin/ldconfig
%postun libs -p /sbin/ldconfig

%clean
rm -rf %{buildroot}

#files -f xen-xm.lang
%files
%defattr(-,root,root)
%doc COPYING README
%doc docs/pdf/
%doc docs/misc/
%{_sbindir}/xend
%{_sbindir}/xm
# XenD / xm python code
%{python_sitearch}/xen-*.egg-info
%{python_sitearch}/pygrub-*.egg-info
%{python_sitearch}/%{name}
%{_libdir}/%{name}
%{_mandir}/man1/xm.1*
%{_mandir}/man5/xend-config.sxp.5*
%{_mandir}/man5/xmdomain.cfg.5*
%dir /usr/lib/xen

%dir %{_datadir}/%{name}
%{_datadir}/%{name}/*.dtd
# Startup script
%{_sysconfdir}/init.d/xend
%{_sysconfdir}/init.d/xendomains
# Guest config files
%config(noreplace) %{_sysconfdir}/%{name}/xmexample*
# Daemon config
%config(noreplace) %{_sysconfdir}/%{name}/xend-*
# xm config
%config(noreplace) %{_sysconfdir}/%{name}/xm-*
# Guest autostart links
%dir %attr(0700,root,root) %{_sysconfdir}/%{name}/auto
# Autostart of guests
%config(noreplace) %{_sysconfdir}/sysconfig/xendomains

# Persistent state for XenD
%dir %{_localstatedir}/lib/%{name}/xend-db/
%dir %{_localstatedir}/lib/%{name}/xend-db/domain
%dir %{_localstatedir}/lib/%{name}/xend-db/migrate
%dir %{_localstatedir}/lib/%{name}/xend-db/vnet
# XenD runtime state
%dir %attr(0700,root,root) %{_localstatedir}/run/xend

%exclude %dir /usr/lib/%{name}/boot
%exclude /usr/lib/xen/boot/hvmloader

%files libs
%defattr(-,root,root)
%{_libdir}/*.so.*
%{_libdir}/fs/*


# All runtime stuff except for XenD/xm python stuff
%files runtime
%defattr(-,root,root)
# Hotplug rules
%config(noreplace) %{_sysconfdir}/udev/rules.d/*

%dir %attr(0700,root,root) %{_sysconfdir}/%{name}
%dir %attr(0700,root,root) %{_sysconfdir}/%{name}/scripts/
%config %attr(0700,root,root) %{_sysconfdir}/%{name}/scripts/*
%config %attr(0700,root,root) %{_sysconfdir}/%{name}/qemu-ifup

%{_sysconfdir}/init.d/blktapctrl
%{_sysconfdir}/init.d/xenstored
%{_sysconfdir}/init.d/xenconsoled

%config(noreplace) %{_sysconfdir}/sysconfig/xenstored
%config(noreplace) %{_sysconfdir}/sysconfig/xenconsoled
%config(noreplace) %{_sysconfdir}/sysconfig/blktapctrl

# Auto-load xen backend drivers
%attr(0755,root,root) %{_sysconfdir}/sysconfig/modules/%{name}.modules

# Rotate console log files
%config(noreplace) %{_sysconfdir}/logrotate.d/xen

# Programs run by other programs
#%%dir %{_libdir}/%{name}
#%%dir %{_libdir}/%{name}/bin
#%%attr(0700,root,root) %{_libdir}/%{name}/bin/*
# QEMU runtime files
%dir %{_datadir}/%{name}/qemu
%dir %{_datadir}/%{name}/qemu/keymaps
%{_datadir}/%{name}/qemu/keymaps/*

# man pages
%{_mandir}/man1/xentop.1*
%{_mandir}/man1/xentrace_format.1*
%{_mandir}/man8/xentrace.8*

%{python_sitearch}/fsimage.so
%{python_sitearch}/grub

# The firmware
%ifnarch ia64
# Avoid owning /usr/lib twice on i386
# %%if "%{_libdir}" != "/usr/lib"
# %%dir /usr/lib/%%{name}
# %%endif
%dir /usr/lib/%{name}/boot
# HVM loader is always in /usr/lib regardless of multilib
/usr/lib/xen/boot/hvmloader
%endif

# General Xen state
%dir %{_localstatedir}/lib/%{name}
%dir %{_localstatedir}/lib/%{name}/dump
%dir %{_localstatedir}/lib/%{name}/images
# Xenstore persistent state
%dir %{_localstatedir}/lib/xenstored
# Xenstore runtime state
%dir %{_localstatedir}/run/xenstored
#%%dir %attr(0700,root,root) %{_localstatedir}/run/xend

# All xenstore CLI tools
%{_bindir}/xenstore-*
%{_bindir}/pygrub
%{_bindir}/xentrace*
# blktap daemon
%{_sbindir}/blktapctrl
%{_sbindir}/tapdisk
# XSM
%{_sbindir}/flask-loadpolicy
# Disk utils
%{_sbindir}/qcow-create
%{_sbindir}/qcow2raw
%{_sbindir}/img2qcow
# Misc stuff
%{_bindir}/xen-detect
%{_sbindir}/xen-bugtool
%{_sbindir}/xenconsoled
%{_sbindir}/xenmon.py*
%{_sbindir}/xentop
%{_sbindir}/xentrace_setmask
%{_sbindir}/xenbaked
%{_sbindir}/xenstored

# Xen logfiles
%dir %attr(0700,root,root) %{_localstatedir}/log/xen
# Guest/HV console logs
%dir %attr(0700,root,root) %{_localstatedir}/log/xen/console

%if %{hv_build}
%files hypervisor
%defattr(-,root,root)
/boot/xen-syms-*
/boot/xen-*.gz
%endif

%files devel
%defattr(-,root,root)
%{_includedir}/*.h
%dir %{_includedir}/xen
%{_includedir}/xen/*
%{_libdir}/*.so
%{_libdir}/*.a

%changelog
* Tue Jul 15 2008 NARITA Koichi <pulsar@momonga-linux.org>
- (3.2.0-11m)
- rebuild against gnutls-2.4.1

* Thu Jun  5 2008 NARITA Koichi <pulsar@momonga-linux.org>
- (3.2.0-10m)
- rebuild against openssl-0.9.8h-1m

* Wed Apr 30 2008 TABUCHI Takaaki <tab@momonga-linux.org>
- (3.2.0-9m)
- restrict python ver-rel for egginfo

* Tue Apr 29 2008 Masahiro Takahata <takahata@momonga-linux.org>
- (3.2.0-8m)
- enable egg-info

* Thu Apr 03 2008 TABUCHI Takaaki <tab@momonga-linux.org>
- (3.2.0-7m)
- rebuild against gcc43

* Fri Feb 15 2008 Ichiro Nakai <ichiro@n.email.ne.jp>
- (3.2.0-6m)
- adjust %%files for the newest python
- BR: python-devel >= 2.5.1-7m

* Mon Feb 11 2008 Ichiro Nakai <ichiro@n.email.ne.jp>
- (3.2.0-5m)
- adjust %%files again for x86_64

* Fri Feb  8 2008 Ichiro Nakai <ichiro@n.email.ne.jp>
- (3.2.0-4m)
- adjust %%files for new python
- BR: python-devel >= 2.5.1-5m

* Thu Feb  7 2008 TABUCHI Takaaki <tab@momonga-linux.org>
- (3.2.0-3m)
- fix files conflicts

* Sat Feb  2 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (3.2.0-2m)
- split xen-runtime

* Thu Jan 31 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (3.2.0-1m)
- update 3.2.0

* Mon Dec  3 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (3.1.2-1m)
- update 3.1.2

* Tue Oct 30 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (3.1.0-3m)
- cleanup spec
- fix CVE-2007-1321, CVE-2007-3919, CVE-2007-4993
-- import Fedora Patches(3.1.0-13)
 
* Mon Jul 23 2007 Nishio Futoshi <futoshi@momonga-linux.org>
- (3.1.0-2m)
- add Requires: initscripts
- fix %%post PATH to service
 
* Tue Jun 19 2007 Mitsuru Shimamura <smbd@momonga-linux.org>
- (3.1.0-1m)
- up to 3.1.0
- be synchronized with fedora
- modify initscripts

* Fri Jun  8 2007 Masahiro Takahata <takahata@momonga-linux.org>
- (3.1.0-0.rc7.1m)
- sync Fedora

* Wed Mar 14 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (3.0.3-4m)
- makimodosi 3.0.3-2

* Wed Mar 14 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (3.0.3-3m)
- add export LDFLAGS="-L/%{_lib} $LDFLAGS"
-- Because /lib/libncurses.so cannot be linked

* Sat Dec 23 2006 Yohsuke Ooi <meke@momonga-linux.org>
- (3.0.3-2m)
- rebuild against python-2.5

* Mon Oct 06 2006 TABUCHI Takaaki <tab@momonga-linux.org>
- (3.0.3-1m)
- merge FC 3.0.3-1

* Fri Jul  7 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (3.0.2-1m)
- import from fc-devel

* Sun Jan  8 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (3.0-0.20051206.1m)
- sync with fc-devel

* Sat Oct 30 2005 TABUCHI Takaaki <tab@momonga-linux.org>
- (2-20051030m)
- rebuild against python-2.4.2

* Wed Mar 23 2005 Masahiro Takahata <takahata@momonga-linux.org>
- (2-20050308m)
- import from FC

* Wed Mar  9 2005 Rik van Riel <riel@redhat.com> 2-20050308
- upgrade to last night's snapshot
- new compile fix patch

* Sun Mar  6 2005 Rik van Riel <riel@redhat.com> 2-20050305
- the gcc4 compile patches are now upstream
- upgrade to last night's snapshot, drop patches locally

* Fri Mar  4 2005 Rik van Riel <riel@redhat.com> 2-20050303
- finally got everything to compile with gcc4 -Wall -Werror

* Thu Mar  3 2005 Rik van Riel <riel@redhat.com> 2-20050303
- upgrade to last night's Xen-unstable snapshot
- drop printf warnings patch, which is upstream now

* Wed Feb 23 2005 Rik van Riel <riel@redhat.com> 2-20050222
- upgraded to last night's Xen snapshot
- compile warning fixes are now upstream, drop patch

* Sat Feb 19 2005 Rik van Riel <riel@redhat.com> 2-20050219
- fix more compile warnings
- fix the fwrite return check

* Fri Feb 18 2005 Rik van Riel <riel@redhat.com> 2-20050218
- upgrade to last night's Xen snapshot
- a kernel upgrade is needed to run this Xen, the hypervisor
  interface changed slightly
- comment out unused debugging function in plan9 domain builder
  that was giving compile errors with -Werror

* Tue Feb  8 2005 Rik van Riel <riel@redhat.com> 2-20050207
- upgrade to last night's Xen snapshot

* Tue Feb  1 2005 Rik van Riel <riel@redhat.com> 2-20050201.1
- move everything to /var/lib/xen

* Tue Feb  1 2005 Rik van Riel <riel@redhat.com> 2-20050201
- upgrade to new upstream Xen snapshot

* Tue Jan 25 2005 Jeremy Katz <katzj@redhat.com>
- add buildreqs on python-devel and xorg-x11-devel (strange AT nsk.no-ip.org)

* Mon Jan 24 2005 Rik van Riel <riel@redhat.com> - 2-20050124
- fix /etc/xen/scripts/network to not break with ipv6 (also sent upstream)

* Fri Jan 14 2005 Jeremy Katz <katzj@redhat.com> - 2-20050114
- update to new snap
- python-twisted is its own package now
- files are in /usr/lib/python now as well, ugh.

* Tue Jan 11 2005 Rik van Riel <riel@redhat.com>
- add segment fixup patch from xen tree
- fix %files list for python-twisted

* Mon Jan 10 2005 Rik van Riel <riel@redhat.com>
- grab newer snapshot, that does start up
- add /var/xen/xend-db/{domain,vnet} to %files section

* Thu Jan  6 2005 Rik van Riel <riel@redhat.com>
- upgrade to new snapshot of xen-unstable

* Mon Dec 13 2004 Rik van Riel <riel@redhat.com>
- build python-twisted as a subpackage
- update to latest upstream Xen snapshot

* Sun Dec  5 2004 Rik van Riel <riel@redhat.com>
- grab new Xen tarball (with wednesday's patch already included)
- transfig is a buildrequire, add it to the spec file

* Wed Dec  1 2004 Rik van Riel <riel@redhat.com>
- fix up Che's spec file a little bit
- create patch to build just Xen, not the kernels

* Wed Dec 01 2004 Che
- initial rpm release
